/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Contents of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.67 - (show annotations) (download)
Sun Aug 19 11:12:35 2012 UTC (22 months, 3 weeks ago) by johu
Branch: MAIN
Changes since 1.66: +1 -45 lines
Remove obsolete koffice handling. Simplify Qt minimal requirement. Remove
duplicated entry for unstable KDE SC releases in SRC_URI calculation. Arrange
docs example for KDE_LINGUAS alphabetically.

1 # Copyright 1999-2012 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: $
4 #
5 # @ECLASS: kde4-meta.eclass
6 # @MAINTAINER:
7 # kde@gentoo.org
8 # @BLURB: Eclass for writing "split" KDE packages.
9 # @DESCRIPTION:
10 # This eclass provides all necessary functions for writing split KDE ebuilds.
11 #
12 # You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13 # Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14
15 [[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
16
17 inherit kde4-base versionator
18
19 KDEMETA_EXPF="pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm"
20 EXPORT_FUNCTIONS ${KDEMETA_EXPF}
21
22 # Add dependencies that all packages in a certain module share.
23 case ${KMNAME} in
24 kdebase|kdebase-apps|kde-baseapps|kdebase-workspace|kde-workspace|kdebase-runtime|kde-runtime|kdegraphics)
25 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
26 ;;
27 kdepim|kdepim-runtime)
28 case ${PN} in
29 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
30 IUSE+=" +kontact"
31 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
32 ;;
33 esac
34 ;;
35 kdegames)
36 if [[ ${PN} != libkdegames ]]; then
37 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
38 fi
39 ;;
40 esac
41
42 DEPEND+=" ${COMMONDEPEND}"
43 RDEPEND+=" ${COMMONDEPEND}"
44 unset COMMONDEPEND
45
46 debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
47 debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
48
49 # Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
50 case ${KDE_BUILD_TYPE} in
51 live)
52 if [[ ${KDE_SCM} == svn ]]; then
53 case ${KMNAME} in
54 extragear*|playground*)
55 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
56 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
57 ;;
58 esac
59 fi
60 ;;
61 esac
62
63 # @ECLASS-VARIABLE: KMNAME
64 # @DESCRIPTION:
65 # Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it
66 # _before_ inheriting this eclass, (unlike the other parameters), since it's
67 # used to set $SRC_URI.
68
69 # @ECLASS-VARIABLE: KMMODULE
70 # @DESCRIPTION:
71 # Specify exactly one subdirectory of $KMNAME here. Defaults to $PN.
72 # The subdirectory listed here is treated exactly like items in $KMEXTRA.
73 #
74 # Example: The ebuild name of "kdebase/l10n" is kde-base/kdebase-l10n, because
75 # just 'l10n' would be too confusing. Hence it sets KMMODULE="l10n".
76
77 # @ECLASS-VARIABLE: KMNOMODULE
78 # @DESCRIPTION:
79 # If set to "true", $KMMODULE doesn't have to be defined.
80 #
81 # Example usage: If you're installing subdirectories of a package, like plugins,
82 # you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
83 # set KMNOMODULE="true".
84 if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
85 KMMODULE=${PN}
86 fi
87
88 # @ECLASS-VARIABLE: KMEXTRA
89 # @DESCRIPTION:
90 # All subdirectories listed here will be extracted, compiled & installed.
91 # $KMMODULE is always added to $KMEXTRA.
92 # If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
93 # directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
94 # documentation in different subdirectories, it should be added to KMEXTRA manually..
95
96 # @ECLASS-VARIABLE: KMCOMPILEONLY
97 # @DESCRIPTION:
98 # All subdirectories listed here will be extracted & compiled, but not installed.
99
100 # TODO: better formulation may be needed
101 # @ECLASS-VARIABLE: KMEXTRACTONLY
102 # @DESCRIPTION:
103 # All subdirectories listed here will be extracted, but neither compiled nor installed.
104 # This can be used to avoid compilation in a subdirectory of a directory in $KMMODULE or $KMEXTRA
105
106 # @ECLASS-VARIABLE: KMTARPARAMS
107 # @DESCRIPTION:
108 # Specify extra parameters to pass to tar, in kde4-meta_src_extract.
109 # '-xpf -j' are passed to tar by default.
110
111 # @FUNCTION: kde4-meta_pkg_setup
112 # @DESCRIPTION:
113 # Currently calls its equivalent in kde4-base.eclass(5) and checks the gcc version.
114 # Use this one in split ebuilds.
115 kde4-meta_pkg_setup() {
116 debug-print-function ${FUNCNAME} "$@"
117
118 kde4-base_pkg_setup
119 }
120
121 # @FUNCTION: kde4-meta_src_unpack
122 # @DESCRIPTION:
123 # This function unpacks the source for split ebuilds.
124 # Further more is processed in kde4-meta_src_extract
125 kde4-meta_src_unpack() {
126 debug-print-function ${FUNCNAME} "$@"
127
128 if [[ ${KDE_BUILD_TYPE} = live ]]; then
129 case "${KDE_SCM}" in
130 svn)
131 migrate_store_dir
132 S="${WORKDIR}/${P}"
133 mkdir -p "${S}"
134 ESVN_RESTRICT="export" subversion_src_unpack
135 subversion_wc_info
136 subversion_bootstrap
137 ;;
138 git)
139 git-2_src_unpack
140 ;;
141 esac
142 fi
143 kde4-meta_src_extract
144 }
145
146 # @FUNCTION: kde4-meta_src_extract
147 # @DESCRIPTION:
148 # A function to extract the source for a split KDE ebuild.
149 # Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
150 # KMTARPARAMS.
151 kde4-meta_src_extract() {
152 debug-print-function ${FUNCNAME} "$@"
153
154 if [[ ${KDE_BUILD_TYPE} = live ]]; then
155 # Export working copy to ${S}
156 einfo "Exporting parts of working copy to ${S}"
157 kde4-meta_create_extractlists
158
159 case ${KDE_SCM} in
160 svn)
161 local rsync_options subdir targetdir wc_path escm
162
163 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/ --exclude=.git/"
164 wc_path="${ESVN_WC_PATH}"
165 escm="{ESVN}"
166
167 # Copy ${KMNAME} non-recursively (toplevel files)
168 rsync ${rsync_options} "${wc_path}"/* "${S}" \
169 || die "${escm}: can't export toplevel files to '${S}'."
170 # Copy cmake directory
171 if [[ -d "${wc_path}/cmake" ]]; then
172 rsync --recursive ${rsync_options} "${wc_path}/cmake" "${S}" \
173 || die "${escm}: can't export cmake files to '${S}'."
174 fi
175 # Copy all subdirectories
176 for subdir in $(__list_needed_subdirectories); do
177 targetdir=""
178 if [[ $subdir = doc/* && ! -e "$wc_path/$subdir" ]]; then
179 continue
180 fi
181
182 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
183 rsync --recursive ${rsync_options} "${wc_path}/${subdir%/}" "${S}/${targetdir}" \
184 || die "${escm}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
185 done
186 ;;
187 esac
188 else
189 local abort tarball tarfile f extractlist postfix
190
191 if [[ ${PV} =~ 4.[47].[12345] ]]; then
192 postfix="bz2"
193 KMTARPARAMS+=" --bzip2"
194 else
195 postfix="xz"
196 KMTARPARAMS+=" --xz"
197 fi
198
199 case ${KMNAME} in
200 kdebase-apps)
201 # kdebase/apps -> kdebase-apps
202 tarball="kdebase-${PV}.tar.${postfix}"
203 ;;
204 *)
205 # Create tarball name from module name (this is the default)
206 tarball="${KMNAME}-${PV}.tar.${postfix}"
207 ;;
208 esac
209
210 # Full path to source tarball
211 tarfile="${DISTDIR}/${tarball}"
212
213 # Detect real toplevel dir from tarball name - it will be used upon extraction
214 # and in __list_needed_subdirectories
215 topdir="${tarball%.tar.*}/"
216
217 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
218
219 kde4-meta_create_extractlists
220
221 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake
222 do
223 extractlist+=" ${topdir}${f}"
224 done
225 extractlist+=" $(__list_needed_subdirectories)"
226
227 pushd "${WORKDIR}" > /dev/null
228
229 # @ECLASS-VARIABLE: KDE4_STRICTER
230 # @DESCRIPTION:
231 # Print out all issues found executing tar / kmextract files
232 # Set on if you want to find issues in kde-base ebuild unpack sequences
233 [[ -n ${KDE4_STRICTER} ]] && echo 'tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}'
234 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null || echo "tar extract command failed at least partially - continuing anyway"
235
236 # Default $S is based on $P; rename the extracted directory to match $S if necessary
237 if [[ ${KMNAME} != ${PN} ]]; then
238 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
239 fi
240
241 popd > /dev/null
242
243 eend $?
244
245 if [[ -n ${KDE4_STRICTER} ]]; then
246 for f in $(__list_needed_subdirectories fatal); do
247 if [[ ! -e ${S}/${f#*/} ]]; then
248 eerror "'${f#*/}' is missing"
249 abort=true
250 fi
251 done
252 [[ -n ${abort} ]] && die "There were missing files."
253 fi
254
255 # We don't need it anymore
256 unset topdir
257 fi
258 }
259
260 # @FUNCTION: kde4-meta_create_extractlists
261 # @DESCRIPTION:
262 # Create lists of files and subdirectories to extract.
263 # Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
264 # KMEXTRACTONLY and KMTARPARAMS.
265 kde4-meta_create_extractlists() {
266 debug-print-function ${FUNCNAME} "$@"
267
268 # Add default handbook locations
269 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
270 if [[ $(get_kde_version) < 4.5 ]] && use_if_iuse handbook && [[ -z ${KMNOMODULE} ]]; then
271 # We use the basename of $KMMODULE because $KMMODULE can contain
272 # the path to the module subdirectory.
273 KMEXTRA_NONFATAL+="
274 doc/${KMMODULE##*/}"
275 fi
276
277 # Add default handbook locations
278 if [[ -z ${KMNOMODULE} ]] && ( [[ ${KDE_HANDBOOK} == always ]] || ( [[ ${KDE_HANDBOOK} == optional ]] && use handbook ) ); then
279 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
280 fi
281
282 # Add some CMake-files to KMEXTRACTONLY.
283 # Note that this actually doesn't include KMEXTRA handling.
284 # In those cases you should care to add the relevant files to KMEXTRACTONLY
285 case ${KMNAME} in
286 kdebase | kdebase-apps | kde-baseapps)
287 KMEXTRACTONLY+="
288 config-apps.h.cmake
289 ConfigureChecks.cmake"
290 ;;
291 kdebase-runtime | kde-runtime)
292 KMEXTRACTONLY+="
293 CTestConfig.cmake
294 config-runtime.h.cmake"
295 ;;
296 kdebase-workspace | kde-workspace)
297 KMEXTRACTONLY+="
298 config-unix.h.cmake
299 ConfigureChecks.cmake
300 config-workspace.h.cmake
301 config-X11.h.cmake
302 startkde.cmake
303 KDE4WorkspaceConfig.cmake.in"
304 ;;
305 kdegames)
306 if [[ ${PN} != libkdegames ]]; then
307 KMEXTRACTONLY+="
308 libkdegames/"
309 KMLOADLIBS="${KMLOADLIBS} libkdegames"
310 fi
311 ;;
312 kdepim)
313 if [[ ${PN} != libkdepim ]]; then
314 KMEXTRACTONLY+="
315 libkdepim/"
316 fi
317 KMEXTRACTONLY+="
318 config-enterprise.h.cmake
319 kleopatra/ConfigureChecks.cmake"
320 if ! [[ $(get_kde_version) < 4.5 ]]; then
321 KMEXTRACTONLY+="
322 CTestCustom.cmake
323 kdepim-version.h.cmake"
324 else
325 KMEXTRACTONLY+="
326 kdepim-version.h"
327 fi
328 if use_if_iuse kontact; then
329 KMEXTRA+="
330 kontact/plugins/${PLUGINNAME:-${PN}}/"
331 fi
332 ;;
333 kdeutils)
334 KMEXTRACTONLY+="
335 kdeutils-version.h"
336 ;;
337 esac
338 # Don't install cmake modules for split ebuilds, to avoid collisions.
339 # note: kdegraphics >= 4.6.2 does not even have code to do that, so we
340 # should not try in that case
341 # note2: kdeedu 4.6.4 does not have a cmake/modules/ subdir anymore :(
342 # it may be possible to formulate this shorter, but it should also
343 # still be understandable...
344 if [[ ${KMNAME} != kdegraphics || ( ( $(get_kde_version) != 4.6 || ${PV} < 4.6.2 ) && $(get_kde_version) < 4.7 ) ]] \
345 && ! [[ ${KMNAME} == kdeedu && ( ${PV} == 4.6.4 || ${PV} == 4.6.5 ) ]]; then
346 case ${KMNAME} in
347 kdebase-runtime|kde-runtime|kdebase-workspace|kde-workspace|kdeedu|kdegames|kdegraphics)
348 KMEXTRACTONLY+="
349 cmake/modules/"
350 ;;
351 esac
352 fi
353
354 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
355 }
356
357 __list_needed_subdirectories() {
358 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
359
360 # We expand KMEXTRA by adding CMakeLists.txt files
361 kmextra="${KMEXTRA}"
362 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
363 for i in ${kmextra}; do
364 kmextra_expanded+=" ${i}"
365 j=$(dirname ${i})
366 while [[ ${j} != "." ]]; do
367 kmextra_expanded+=" ${j}/CMakeLists.txt";
368 j=$(dirname ${j})
369 done
370 done
371
372 # Expand KMMODULE
373 if [[ -n ${KMMODULE} ]]; then
374 kmmodule_expanded="${KMMODULE}"
375 j=$(dirname ${KMMODULE})
376 while [[ ${j} != "." ]]; do
377 kmmodule_expanded+=" ${j}/CMakeLists.txt";
378 j=$(dirname ${j})
379 done
380 fi
381
382 # Expand KMCOMPILEONLY
383 for i in ${KMCOMPILEONLY}; do
384 kmcompileonly_expanded+=" ${i}"
385 j=$(dirname ${i})
386 while [[ ${j} != "." ]]; do
387 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
388 j=$(dirname ${j})
389 done
390 done
391
392 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
393 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}"
394 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}"
395
396 # Create final list of stuff to extract
397 # We append topdir only when specified (usually for tarballs)
398 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
399 ${KMEXTRACTONLY}
400 do
401 extractlist+=" ${topdir}${i}"
402 done
403
404 echo ${extractlist}
405 }
406
407 # @FUNCTION: kde4-meta_src_prepare
408 # @DESCRIPTION:
409 # Meta-package build system configuration handling - commenting out targets, etc..
410 kde4-meta_src_prepare() {
411 debug-print-function ${FUNCNAME} "$@"
412
413 kde4-meta_change_cmakelists
414 kde4-base_src_prepare
415 }
416
417 # @FUNCTION: _change_cmakelists_parent_dirs
418 # @DESCRIPTION:
419 # Adjust CMakeLists.txt to shadow subdirectories
420 # that are not required for the build.
421 _change_cmakelists_parent_dirs() {
422 debug-print-function ${FUNCNAME} "$@"
423
424 local _olddir _dir
425 _dir="${S}"/${1}
426 until [[ ${_dir} == ${S} ]]; do
427 _olddir=$(basename "${_dir}")
428 _dir=$(dirname "${_dir}")
429 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
430 if [[ -f ${_dir}/CMakeLists.txt ]]; then
431 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
432 -e "/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
433 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
434 fi
435 done
436 }
437
438 # @FUNCTION: kde4-meta_change_cmakelists
439 # @DESCRIPTION:
440 # Adjust CMakeLists.txt to comply to our splitting.
441 kde4-meta_change_cmakelists() {
442 debug-print-function ${FUNCNAME} "$@"
443
444 pushd "${S}" > /dev/null
445
446 comment_all_add_subdirectory ./
447
448 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
449 if [[ -f CMakeLists.txt ]]; then
450 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
451 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
452 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
453 fi
454
455 # Restore "add_subdirectory( ${ ..." (this is done in kdesdk)
456 if [[ -f CMakeLists.txt ]]; then
457 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*\${/s/^#DONOTCOMPILE //' \
458 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*\${/s/^#DONOTCOMPILE //' \
459 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
460 fi
461
462 if [[ -z ${KMNOMODULE} ]]; then
463 # Restore "add_subdirectory" in $KMMODULE subdirectories
464 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
465 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
466 die "${LINENO}: died in KMMODULE section"
467 _change_cmakelists_parent_dirs ${KMMODULE}
468 fi
469
470 local i
471
472 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
473 for i in ${KMEXTRACTONLY}; do
474 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
475 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
476 -i ${i}/../CMakeLists.txt || \
477 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
478 fi
479 done
480
481 # KMCOMPILEONLY
482 for i in ${KMCOMPILEONLY}; do
483 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}"
484 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions.
485 find "${S}"/${i} -name CMakeLists.txt -print0 | \
486 xargs -0 sed -i \
487 -e 's/^#DONOTCOMPILE //g' \
488 -e '/install(.*)/{s/^/#DONOTINSTALL /;}' \
489 -e '/^install(/,/)/{s/^/#DONOTINSTALL /;}' \
490 -e '/kde4_install_icons(.*)/{s/^/#DONOTINSTALL /;}' || \
491 die "${LINENO}: sed died in the KMCOMPILEONLY section while processing ${i}"
492 _change_cmakelists_parent_dirs ${i}
493 done
494
495 # KMEXTRA section
496 for i in ${KMEXTRA}; do
497 debug-print "${LINENO}: KMEXTRA section, processing ${i}"
498 find "${S}"/${i} -name CMakeLists.txt -print0 | \
499 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
500 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
501 _change_cmakelists_parent_dirs ${i}
502 done
503 # KMEXTRA_NONFATAL section
504 for i in ${KMEXTRA_NONFATAL}; do
505 if [[ -d "${S}"/${i} ]]; then
506 find "${S}"/${i} -name CMakeLists.txt -print0 | \
507 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
508 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
509 _change_cmakelists_parent_dirs ${i}
510 fi
511 done
512
513 case ${KMNAME} in
514 kdebase-workspace | kde-workspace)
515 # COLLISION PROTECT section
516 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
517 # not as a part of every package.
518 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
519 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
520 sed -e '/startkde/s/^/#DONOTINSTALL /' \
521 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
522 fi
523 # Remove workspace target prefix in order to get direct linking to workspace libs
524 sed -e '/set(KDE4WORKSPACE_TARGET_PREFIX/s/^/#OVERRIDE /' \
525 -i CMakeLists.txt || die "${LINENO}: sed died in KDE4WORKSPACE_TARGET_PREFIX removal section"
526 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
527 if [[ ${PN} != libkworkspace ]]; then
528 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
529 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace strip config install and fix EXPORT section"
530 fi
531 if [[ ${PN} != plasma-workspace ]]; then
532 sed -e '/KActivities/s/REQUIRED//' \
533 -i CMakeLists.txt || die "${LINENO}: sed died in kde-workspace dep reduction section"
534 fi
535 if [[ "${PN}" != "kwin" ]]; then
536 sed -i -e "/^ macro_log_feature(OPENGL_OR_ES_FOUND/s/TRUE/FALSE/" \
537 "${S}"/CMakeLists.txt || die "${LINENO}: sed died removing kde-workspace opengl dependency"
538 fi
539 ;;
540 kdebase-runtime | kde-runtime)
541 # COLLISION PROTECT section
542 # Only install the kde4 script as part of kde-base/kdebase-data
543 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
544 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
545 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
546 fi
547 ;;
548 kdenetwork)
549 # Disable hardcoded kdepimlibs check
550 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
551 -i CMakeLists.txt || die "failed to disable hardcoded checks"
552 ;;
553 kdepim)
554 # Disable hardcoded checks
555 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
556 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
557 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
558 -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*/if(1) # &/' \
559 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
560 -i CMakeLists.txt || die "failed to disable hardcoded checks"
561 # Disable broken or redundant build logic
562 if use_if_iuse kontact || [[ ${PN} = kontact ]]; then
563 sed -e 's/if[[:space:]]*([[:space:]]*BUILD_.*)[[:space:]]*$/if(1) # &/' \
564 -e 's/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)[[:space:]]*$/if(1) # &/' \
565 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
566 fi
567 if [[ $(get_kde_version) < 4.5 ]]; then
568 case ${PN} in
569 kalarm|kmailcvt|kontact|korganizer|korn)
570 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
571 -e '/add_custom_target(kmail_xml /,/)/p' \
572 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
573 _change_cmakelists_parent_dirs kmail
574 ;;
575 esac
576 fi
577 ;;
578 kdewebdev)
579 # Disable hardcoded checks
580 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
581 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
582 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
583 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
584 -i CMakeLists.txt || die "failed to disable hardcoded checks"
585 ;;
586 esac
587
588 popd > /dev/null
589 }
590
591 # @FUNCTION: kde4-meta_src_configure
592 # @DESCRIPTION:
593 # Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
594 # ebuilds.
595 kde4-meta_src_configure() {
596 debug-print-function ${FUNCNAME} "$@"
597
598 # backwards-compatibility: make mycmakeargs an array, if it isn't already
599 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
600 mycmakeargs=(${mycmakeargs})
601 fi
602
603 # Set some cmake default values here (usually workarounds for automagic deps)
604 case ${KMNAME} in
605 kdewebdev)
606 mycmakeargs=(
607 -DWITH_KdepimLibs=OFF
608 -DWITH_LibXml2=OFF
609 -DWITH_LibXslt=OFF
610 -DWITH_Boost=OFF
611 -DWITH_LibTidy=OFF
612 "${mycmakeargs[@]}"
613 )
614 ;;
615 esac
616
617 kde4-base_src_configure
618 }
619
620 # @FUNCTION: kde4-meta_src_compile
621 # @DESCRIPTION:
622 # General function for compiling split KDE4 applications.
623 # Overrides kde4-base_src_compile.
624 kde4-meta_src_compile() {
625 debug-print-function ${FUNCNAME} "$@"
626
627 kde4-base_src_compile "$@"
628 }
629
630 # @FUNCTION: kde4-meta_src_test
631 # @DESCRIPTION:
632 # Currently just calls its equivalent in kde4-base.eclass(5) if
633 # I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
634 kde4-meta_src_test() {
635 debug-print-function $FUNCNAME "$@"
636
637 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
638 kde4-base_src_test
639 else
640 einfo "Tests disabled"
641 fi
642 }
643
644 # @FUNCTION: kde4-meta_src_install
645 # @DESCRIPTION:
646 # Function for installing KDE4 split applications.
647 kde4-meta_src_install() {
648 debug-print-function $FUNCNAME "$@"
649
650 # Search ${S}/${KMMODULE} and install common documentation files found
651 local doc
652 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
653 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
654 done
655
656 kde4-base_src_install
657 }
658
659 # @FUNCTION: kde4-meta_pkg_preinst
660 # @DESCRIPTION:
661 # Invoke its equivalent in kde4-base.eclass.
662 kde4-meta_pkg_preinst() {
663 debug-print-function ${FUNCNAME} "$@"
664
665 kde4-base_pkg_preinst
666 }
667
668 # @FUNCTION: kde4-meta_pkg_postinst
669 # @DESCRIPTION:
670 # Invoke kbuildsycoca4.
671 kde4-meta_pkg_postinst() {
672 debug-print-function ${FUNCNAME} "$@"
673
674 kde4-base_pkg_postinst
675 }
676
677 # @FUNCTION: kde4-meta_pkg_postrm
678 # @DESCRIPTION:
679 # Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
680 # ebuilds.
681 kde4-meta_pkg_postrm() {
682 debug-print-function ${FUNCNAME} "$@"
683
684 kde4-base_pkg_postrm
685 }

  ViewVC Help
Powered by ViewVC 1.1.20